/* MERG Content-to-template merger
   Command line:
      MERG [switches] template content1 content2 ...

   Valid switches:
      h        allow/Suppress HTML tags in content
      n        Keep/discard name
      l        long file name Acceptable/truncate
      e ERROR  Output error messages to ERROR
               instead of STD_ERR
      q        Quiet mode


token.c Token manipulation functions
This file contains a set of functions used by the parsers
in manipulating tokens. 
*/

#include "merg.h"

int tknDirect = 0;

char * TokenContent (TOKEN * token, char * content)
{
	if(!tknDirect){
		if(content){
			if(token->szContent)
				MemFree(token->szContent);
			token->szContent = (char *) MemAlloc (strlen(content)+1);
			strcpy (token->szContent, content);
			return token->szContent;
		}
		else
			return token->szContent;
	}
	else
		return token->szContent = content;
}

char * TokenName (TOKEN * token, char * name)
{
	if(name){
		if(token->strTokenName)
			MemFree(token->strTokenName);
		token->strTokenName = (char *) MemAlloc (strlen(name)+1);
		strcpy (token->strTokenName, name);
		return token->strTokenName;
	}
	else
		return token->strTokenName;
}

int TokenType (TOKEN * token, int type)
{
	if(type){
		token->nTokenID = type;
		return token->nTokenID;
	}
	else
		return token->nTokenID;
}

int FreeToken (TOKEN * token)
{
	if(!tknDirect){
		if(token->szContent)
			MemFree(token->szContent);
		
	}
	if (token->strTokenName)
		MemFree(token->strTokenName);

	return 0;
}

TOKEN * CreateToken (TOKEN * prev)
{
	TOKEN * result;
	
	if (!prev)
		result = (TOKEN *) MemAlloc (sizeof(TOKEN));
	else
		result = prev;

	result->szContent = NULL;
	result->strTokenName = NULL;
	result->nTokenID = TKN_UNKNOWN;

	return result;
}
